config/routes.rb
Rails.application.routes.draw do
  get 'recruitments/index'

  match '/404', :to => "errors#not_found", :via => :all
  match '/500', :to => "errors#internal_server_error", :via => :all

  resources :notifications do
    put :read
    get :follow
  end
  put 'notifications/:project_id/read_all', to: 'notifications#read_all', as: 'notifications_read_all'
  get 'notifications_check' => 'notifications#check'

  mount Attachinary::Engine => '/attachinary'

  resources :goals
  resources :cycles
  devise_for :thinkers, :controllers => {
    :sessions      => 'thinkers/sessions',
    :registrations => 'thinkers/registrations',
    :notifications => 'notifications'
  }

  resources :password, only: [:edit, :update]
  resources :otp, only: [:show] do
    member do
      put :enable
      put :disable
      put :codes
    end
  end

  resources :workloads
  resources :statuses
  resources :dependences
  resources :thinkers do
    resources :skills, except: [:show, :update, :edit], controller: 'thinkers/skills'
    resources :notifications, except: [:new], controller: 'thinkers/notifications'
    resources :preferences, only: [:edit, :update], controller: 'thinkers/preferences', path: 'thinkers/preferences', shallow: true

    member do
      get :dashboard
    end
  end
  resources :licenses
  resources :languages
  resources :projects do
    member do
      put :contribute
      put :elect
      put :migrate
      put :suspend
      put :resume
    end

    resources :teams do
      member do
        get 'ban'
        get 'unban'
      end
    end

    resources :statistics, only: [:show], controller: 'projects/statistics'

    resources :releases, shallow: true
    resources :election_polls, shallow: true
    namespace :settings, :module => :projects do
      resources :links, :controller   => :settings_links, :only   => [:index, :create]
      resources :other, :controller   => :settings_other, :only   => [:index, :create]
      resources :release, :controller => :settings_release, :only => [:index, :create]
      resources :skills, :controller => :settings_skills, except: [:show, :update, :edit]
      resources :father, :controller => :settings_father, :only => [:index, :create, :destroy]
      resources :images, :controller => :settings_images, :only => [:index, :create]
      resources :contribution_types, :controller => :settings_contribution_types, :only => [:index, :create]
    end

    resources :sprints, shallow: true do
      resources :survey, only: [:index, :create, :new]
    end

    resources :recruitments, shallow: true do
      member do
        put :approve
        put :reopen
      end
    end

    resources :tasks, shallow: true do
      member do
        put :sprint
        put :release
        put :assign
        put :judge
        put :reopen
        put :give_up
      end

      resources :comments, only: [:create, :edit, :update, :destroy], shallow: true do
        resources :reasons, shallow: true

        member do
          get :approve
          get :like
        end
      end

      resources :operations, shallow: true, except: [:new, :show] do
        member do
          put :done
        end
      end

      resource :ratings, only: [:create], shallow: true
    end

    resources :goals, shallow: true do
      member do
        put :tasks_in_sprint
      end
    end
  end
  resources :start, only: [:index]
  resources :how_does_it_works
  resources :faqs

  root "start#index"

end

app/models/operation.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class Operation < ActiveRecord::Base
  acts_as_paranoid

  belongs_to :task

  before_create :generate_serial

  def destroy_and_update_serial
    ActiveRecord::Base.transaction do
      begin
        task
          .operations
          .where('serial > ?', serial)
          .update_all('serial = serial - 1')

        really_destroy!
      rescue => ex
        puts ex.message
      end
    end
  end

  private

  def generate_serial
    operations_count = Operation.where(task_id: task.id).count + 1

    self.serial = operations_count
  end
end

app/controllers/operations_controller.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class OperationsController < ApplicationController
  before_action :authenticate_thinker!
  before_action :set_operation, only: [:show, :edit, :update, :destroy, :done]
  before_action :set_task, only: [:index, :new, :create]
  before_action :check_worker!, except: [:index, :destroy, :done]
  before_action :set_project, only: [:index]

  # GET /operations
  # GET /operations.json
  def index
    @operations = @task
                  .operations
                  .with_deleted
                  .order('serial')
                  .all

    @workload_voted = @task
                      .votes
                      .with_deleted
                      .where(thinker: current_thinker)
                      .first

    @breadcrumbs = {
      "project_tasks_path('#{@task.project.slug}')" => I18n.t('breadcrumbs.project_tasks_path'),
      "task_path(#{@task.id})"                 => "\##{@task.serial} <span class='hidden-xs'>#{@task.title}</span>",
      'nil' => I18n.t('operations_t')
    }
  end

  # GET /operations/1/edit
  def edit
  end

  # POST /operations
  # POST /operations.json
  def create
    @operation = Operation.new(operation_params)
    @operation.task = @task

    respond_to do |format|
      if @operation.save
        create_notification(@operation, @operation.task.project)
        format.html { redirect_to task_operations_path(@task), notice: 'Operation was successfully added.' }
        format.json { render :show, status: :created, location: @operation }
      else
        format.html { render :new }
        format.json { render json: @operation.errors, status: :unprocessable_entity }
      end
    end
  end

  def done
    @operation.done = true
    @task           = @operation.task

    respond_to do |format|
      if @task.worker == current_thinker && @operation.save
        create_notification(@operation, @operation.task.project)
        format.html { redirect_to task_operations_path(@task), notice: 'Operation done.' }
        format.json { render :show, status: :created, location: @operation }
      else
        format.html { render :new }
        format.json { render json: @operation.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /operations/1
  # PATCH/PUT /operations/1.json
  def update
    respond_to do |format|
      if @operation.update(operation_params)
        create_notification(@operation, @operation.task.project)
        format.html { redirect_to @operation, notice: 'Operation was successfully updated.' }
        format.json { render :show, status: :ok, location: @operation }
      else
        format.html { render :edit }
        format.json { render json: @operation.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /operations/1
  # DELETE /operations/1.json
  def destroy
    @task = @operation.task

    respond_to do |format|
      if @task.worker == current_thinker && @operation.destroy_and_update_serial
        destroy_notification(@operation, @operation.task.project)
        format.html { redirect_to task_operations_path(@task), notice: 'Operation was successfully destroyed.' }
      else
        format.html { redirect_to task_operations_path(@task), alert: 'You cannot delete operations.' }
      end
    end
  end

  private

  def check_worker!
    redirect_to task_path(@task) unless current_thinker == @task.worker
  end

  def set_task
    @task = Task.with_deleted.find(params[:task_id])
  end

  def set_project
    @project = @task.project
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_operation
    @operation = Operation.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def operation_params
    params.require(:operation).permit(:text)
  end
end

app/helpers/operations_helper.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

module OperationsHelper
  def done_button(operation)
    link_to done_operation_path(operation), :class => "pull-right btn actions", :role => "button", :title => t("done"), method: :put do
      content_tag(:span, "", :class => "glyphicon glyphicon-ok", "aria-hidden" => "true")
    end
  end

  def destroy_button(operation)
    link_to operation_path(operation), :class => "pull-right btn actions", :role => "button", :title => t("remove"), method: :delete do
      content_tag(:span, '', :class => 'glyphicon glyphicon-remove', 'aria-hidden' => 'true')
    end
  end
end

app/views/operations/_form.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

= form_for @operation do |f|
  - if @operation.errors.any?
    #error_explanation
      %h2= "#{pluralize(@operation.errors.count, "error")} prohibited this operation from being saved:"
      %ul
        - @operation.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :serial
    = f.number_field :serial
  .field
    = f.label :text
    = f.text_field :text
  .field
    = f.label :done
    = f.check_box :done
  .actions
    = f.submit 'Save'

app/views/operations/edit.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%h1 Editing operation

= render 'form'

= link_to 'Show', @operation
\|
= link_to 'Back', operations_path

app/views/operations/index.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

= render partial: 'shared/projectbar', locals: { project: @task.project }
.row
  .col-sm-4
    = render partial: 'shared/taskstatuspanel', locals: { task: @task, workload_voted: @workload_voted }
  .col-sm-8
    = render partial: 'shared/taskbody', locals: { task: @task }
    .panel.panel-default
      .panel-heading
        %strong
          Operations
      %ul.list-group
        - if @operations.empty?
          = content_tag(:li, t("no_operations"), :class => "list-group-item")
        - first = false
        - @operations.each_with_index do |operation, index|
          = content_tag(:li, :class => "list-group-item #{operation.done ? 'list-group-item-success' : ''}") do
            - if (!operation.done && !first)
              - first = true
              - if current_thinker == @task.worker
                = destroy_button(operation)
                = done_button(operation)
            %strong
              = operation.serial.to_s + ': '
            = operation.text
      - if current_thinker == @task.worker
        .panel-footer
          = form_for [@task, Operation.new] do |f|
            .input-group
              = f.text_field :text, :class => 'form-control'
              .input-group-btn
                = f.submit t(".add"), :class => "btn btn-primary"

app/views/operations/new.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%h1 New operation

= render 'form'

= link_to 'Back', operations_path

app/views/operations/show.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%p#notice= notice

%p
  %b Serial:
  = @operation.serial
%p
  %b Text:
  = @operation.text
%p
  %b Done:
  = @operation.done

= link_to 'Edit', edit_operation_path(@operation)
\|
= link_to 'Back', operations_path